// XpButtonExCtl.cpp : Implementation of the CXpButtonExCtrl ActiveX Control class.

#include "stdafx.h"
#include "xpButtonEx.h"
#include "XpButtonExCtl.h"
#include "XpButtonExPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CXpButtonExCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CXpButtonExCtrl, COleControl)
	//{{AFX_MSG_MAP(CXpButtonExCtrl)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(OCM_COMMAND, OnOcmCommand)
	ON_MESSAGE(OCM_DRAWITEM, OnOcmDrawItem)
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CXpButtonExCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CXpButtonExCtrl)
	DISP_PROPERTY_NOTIFY(CXpButtonExCtrl, "title", m_title, OnTitleChanged, VT_BSTR)
	DISP_STOCKPROP_FONT()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CXpButtonExCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CXpButtonExCtrl, COleControl)
	//{{AFX_EVENT_MAP(CXpButtonExCtrl)
	EVENT_STOCK_CLICK()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CXpButtonExCtrl, 2)
	PROPPAGEID(CXpButtonExPropPage::guid)
    PROPPAGEID(CLSID_CFontPropPage)
END_PROPPAGEIDS(CXpButtonExCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CXpButtonExCtrl, "XPBUTTONEX.XpButtonExCtrl.1",
	0xa4545e47, 0x89ca, 0x11d6, 0xaf, 0x8d, 0, 0x3, 0x47, 0x88, 0x98, 0x58)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CXpButtonExCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DXpButtonEx =
		{ 0xa4545e45, 0x89ca, 0x11d6, { 0xaf, 0x8d, 0, 0x3, 0x47, 0x88, 0x98, 0x58 } };
const IID BASED_CODE IID_DXpButtonExEvents =
		{ 0xa4545e46, 0x89ca, 0x11d6, { 0xaf, 0x8d, 0, 0x3, 0x47, 0x88, 0x98, 0x58 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwXpButtonExOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CXpButtonExCtrl, IDS_XPBUTTONEX, _dwXpButtonExOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::CXpButtonExCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CXpButtonExCtrl

BOOL CXpButtonExCtrl::CXpButtonExCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_XPBUTTONEX,
			IDB_XPBUTTONEX,
			afxRegInsertable | afxRegApartmentThreading,
			_dwXpButtonExOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::CXpButtonExCtrl - Constructor

CXpButtonExCtrl::CXpButtonExCtrl()
{
	InitializeIIDs(&IID_DXpButtonEx, &IID_DXpButtonExEvents);

	// TODO: Initialize your control's instance data here.
	 m_bOverControl = FALSE;
  pBoundryPen = new CPen(PS_INSIDEFRAME|PS_SOLID,1,RGB(0,0,0));
  pInsideBoundryPenLeft = new CPen(PS_INSIDEFRAME|PS_SOLID,3,RGB(250,196,88)); 
  pInsideBoundryPenRight = new CPen(PS_INSIDEFRAME|PS_SOLID,3,RGB(251,202,106)); 
  pInsideBoundryPenTop = new CPen(PS_INSIDEFRAME|PS_SOLID,2,RGB(252,210,121)); 
  pInsideBoundryPenBottom = new CPen(PS_INSIDEFRAME|PS_SOLID,2,RGB(229,151,0)); 
  pFillActive = new CBrush(RGB(222,223,236));
  pFillInactive = new CBrush(RGB(222,223,236));
 
  //strCaption = "Caption";
  //m_title = "caption";
}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::~CXpButtonExCtrl - Destructor

CXpButtonExCtrl::~CXpButtonExCtrl()
{
	// TODO: Cleanup your control's instance data here.
	 pBoundryPen->DeleteObject();
  pFillActive->DeleteObject();
  pFillInactive->DeleteObject();
  pOldPen->DeleteObject();
  pOldBrush->DeleteObject();
  pInsideBoundryPenLeft->DeleteObject();
  pInsideBoundryPenRight->DeleteObject();
  pInsideBoundryPenBottom->DeleteObject();
  pInsideBoundryPenTop->DeleteObject();

}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::OnDraw - Drawing function

void CXpButtonExCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	DoSuperclassPaint(pdc, rcBounds);
}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::DoPropExchange - Persistence support

void CXpButtonExCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
    PX_String( pPX, _T("title"), m_title, _T("Caption"));

}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::OnResetState - Reset control to default state

void CXpButtonExCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::AboutBox - Display an "About" box to the user

void CXpButtonExCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_XPBUTTONEX);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::PreCreateWindow - Modify parameters for CreateWindowEx

BOOL CXpButtonExCtrl::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.lpszClass = _T("BUTTON");
	return COleControl::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::IsSubclassedControl - This is a subclassed control

BOOL CXpButtonExCtrl::IsSubclassedControl()
{
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl::OnOcmCommand - Handle command messages

LRESULT CXpButtonExCtrl::OnOcmCommand(WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32
	WORD wNotifyCode = HIWORD(wParam);
#else
	WORD wNotifyCode = HIWORD(lParam);
#endif

	// TODO: Switch on wNotifyCode here.
   switch (wNotifyCode)
	{
	case BN_CLICKED:
		// Fire click event when button is clicked

		//FireClick();
		break;

	}

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CXpButtonExCtrl message handlers

int CXpButtonExCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	return 0;
}

BOOL CXpButtonExCtrl::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	return COleControl::OnEraseBkgnd(pDC);
}

void CXpButtonExCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	COleControl::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CXpButtonExCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
//	strCaption = "newCaption";
 
	COleControl::OnLButtonDown(nFlags, point);
	if(m_bOverControl)
	{
	//	AfxMessageBox("clicked");
     m_bOverControl = FALSE;
	 InvalidateControl();
	}
}

void CXpButtonExCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	strCaption = "Caption";
	m_bOverControl = FALSE;
	COleControl::OnLButtonUp(nFlags, point);
}

void CXpButtonExCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	COleControl::OnMouseMove(nFlags, point);
	if(!m_bOverControl)
	{
	 m_bOverControl = TRUE;
	 Invalidate(FALSE);
	 TRACKMOUSEEVENT tm;
	 tm.cbSize = sizeof(tm);
	 tm.dwFlags = TME_LEAVE;
	 tm.hwndTrack = this->m_hWnd;//       m_hwnd;
	 ::_TrackMouseEvent(&tm);
	}
}

void CXpButtonExCtrl::OnSize(UINT nType, int cx, int cy) 
{
	COleControl::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
}

void CXpButtonExCtrl::PreSubclassWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	COleControl::PreSubclassWindow();
	ModifyStyle(0, BS_OWNERDRAW|BS_NOTIFY);

}
LRESULT CXpButtonExCtrl::OnOcmDrawItem(WPARAM wParam, LPARAM lParam)
{
	UINT nIDCtl = (UINT) wParam;
	LPDRAWITEMSTRUCT lpDrawItemStruct = (LPDRAWITEMSTRUCT) lParam;
	CDC* pDC   = CDC::FromHandle(lpDrawItemStruct->hDC);
    CRect rect = lpDrawItemStruct->rcItem;
    UINT state = lpDrawItemStruct->itemState;

   // CString strText;
   // GetWindowText(strText);
     
    // draw the control edges (DrawFrameControl is handy!)
	CPoint pt;
	pt.x = 10;
	pt.y = 10;
  
    pOldPen = pDC->SelectObject(pBoundryPen);
    if (state & ODS_SELECTED)
       pDC->RoundRect(rect,pt);  //pDC->DrawFrameControl(rect, DFC_BUTTON, DFCS_BUTTONPUSH | DFCS_PUSHED);
    else
       pDC->RoundRect(rect,pt);// pDC->DrawFrameControl(rect, DFC_BUTTON, DFCS_BUTTONPUSH);
    
    pDC->SelectObject(pOldPen);
	// Deflate the drawing rect by the size of the button's edges
    rect.DeflateRect( CSize(GetSystemMetrics(SM_CXEDGE), GetSystemMetrics(SM_CYEDGE)));
    // Fill the interior color if necessary

   if (m_bOverControl)
   {
      pOldBrush = pDC->SelectObject(pFillActive);   
      //pDC->FloodFill(rect.left+5,rect.top+5,RGB(0,0,0));  //pDC->FillSolidRect(rect, RGB(255, 255, 0)); // yellow
	  DoGradientFill(pDC,rect);
	  DrawInsideBorder(pDC,rect);
   }
   else
   {
	  pOldBrush = pDC->SelectObject(pFillInactive);   
	  //pDC->FloodFill(rect.left+5,rect.top+5,RGB(0,0,0));  //pDC->FillSolidRect(rect, RGB(0, 0, 255)); // yellow
	  DoGradientFill(pDC,rect);
   }
   pDC->SelectObject(pOldBrush);
    
	  // Draw the text
    if (!m_title.IsEmpty()/*!strText.IsEmpty()*/)
    {
        CSize Extent = pDC->GetTextExtent(m_title/*strText*/);
        CPoint pt( rect.CenterPoint().x - Extent.cx/2, 
        rect.CenterPoint().y - Extent.cy/2 );

        if (state & ODS_SELECTED) 
            pt.Offset(1,1);

        int nMode = pDC->SetBkMode(TRANSPARENT);
        //pOldPen = pDC->SelectObject(pBoundryPen);
        CFont *pOldFont = SelectStockFont( pDC );
		
        if (state & ODS_DISABLED)
            pDC->DrawState(pt, Extent, m_title/*strCaption*/, DSS_DISABLED, TRUE, 0, (HBRUSH)NULL);
        else
            pDC->TextOut(pt.x, pt.y, m_title/*strCaption*/);
        //pDC->SelectObject(pOldPen);
		pDC->SelectObject(pOldFont);
        pDC->SetBkMode(nMode);
    }
	return 0;
}
LRESULT CXpButtonExCtrl::OnMouseLeave(WPARAM, LPARAM)
{
   m_bOverControl = FALSE;
  Invalidate(FALSE);
  return 0;
}
void CXpButtonExCtrl::DoGradientFill(CDC *pDC, CRect rect)
{
/*
    CBrush* pBrush[64];
    for (int i=0; i<64; i++)
        pBrush[i] = new CBrush(RGB(253-(i*4), 253-(i*2), 253-i));//pBrush[i] = new CBrush(RGB(0, 255 - (i * 4), 0));

    int nWidth = (rect.right-1) - (rect.left);
    int nHeight = (rect.bottom) - (rect.top);
    CRect rct;

    for (i=rect.top+2; i<nHeight; i++) {
        rct.SetRect (rect.left+2, i, nWidth, i + 1);
        pDC->FillRect (&rct, pBrush[(i * 63) / nHeight]);
    }

    for (i=0; i<64; i++)
        delete pBrush[i];
*/
	CBrush* pBrush[64];
    for (int i=0; i<64; i++)
		pBrush[i] = new CBrush(RGB(253-(i/2), 253-(i/3), 253-(i/4)));

	//pBrush[i] = new CBrush(RGB(253-(i/3), 253-(i/3), 253-(i/3)));
	//pBrush[i] = new CBrush(RGB(253-(i/2), 253-(i/2), 253-(i/4)));
	//pBrush[i] = new CBrush(RGB(0, 255 - (i * 4), 0));

    int nWidth = (rect.right) - (rect.left);
    int nHeight = (rect.bottom) - (rect.top);
    CRect rct;

    for (i=rect.top; i<nHeight+2; i++) 
	{
        rct.SetRect (rect.left, i, nWidth+2, i + 1);
        pDC->FillRect (&rct, pBrush[(i * 63) / nHeight]);
    }

    for (i=0; i<64; i++)
        delete pBrush[i];

}
void CXpButtonExCtrl::DrawInsideBorder(CDC *pDC,CRect rect)
{
  pOldPen = pDC->SelectObject(pInsideBoundryPenLeft);
  pDC->MoveTo(rect.left,rect.bottom-3);
  pDC->LineTo(rect.left,rect.top+2);
  pDC->SelectObject(pInsideBoundryPenRight);
  pDC->MoveTo(rect.right-1,rect.bottom-3);
  pDC->LineTo(rect.right-1,rect.top+2);
  pDC->SelectObject(pInsideBoundryPenTop);
  pDC->MoveTo(rect.left+2,rect.top);
  pDC->LineTo(rect.right-2,rect.top);
  pDC->SelectObject(pInsideBoundryPenBottom);
  pDC->MoveTo(rect.left+2,rect.bottom);
  pDC->LineTo(rect.right-2,rect.bottom);
  pDC->SelectObject(pOldPen);
}

void CXpButtonExCtrl::OnTitleChanged() 
{
	// TODO: Add notification handler code
	strCaption = m_title;
//	PutTitle("asdasd");
	SetWindowText(m_title);
	SetModifiedFlag();
}
